#include <stdio.h>
int main()
{
	char *tmp  = "tmp";
	char *tmp2 = "tmp2";
	char *hello = "hello world";
	char buff[128];
	FILE *f;
	int fd;

	close(creat(tmp, 0644));


	printf("access %s: %d\n", tmp, access(tmp, 2));
	printf("chmod %s 0\n", tmp, chmod(tmp, 0));
	printf("access %s: %d\n", tmp, access(tmp, 2));
	printf("chmod %s 0644\n", tmp, chmod(tmp, 0644));
	printf("access /foobar: %d\n",  access("/foobar", 2));

	printf("acct: %d\n",  acct("acct"));

	/* alarm is tested trough sleep(3) */

	printf("chdir .: %d\n", chdir("."));
	printf("chdir /foobar: %d\n", chdir("/foobar"));
	printf("chroot /foobar: %d\n", chroot("/foobar"));

	/* chown is untested because it is privileged */

	/* exec* and fork have a separate test called exec.c */

	f = fopen(tmp, "w+");
	fprintf(f, "%s", hello);
	fflush(f);

	fd = dup(fileno(f));
	printf("lseek: %d\n", lseek(fd, 0, 0));
	printf("read: %d\n", read(fd, buff, sizeof(buff)));
	printf("test string returns: %d ('%s' vs. '%s')\n", strcmp(hello, buff), hello, buff);
	close(fd);

	fd = dup2(fileno(f), 16);
	printf("dup2 fd: %d (should be 16)\n", fd);
	printf("lseek: %d\n", lseek(fd, 0, 0));
	printf("read: %d\n", read(fd, buff, sizeof(buff)));
	printf("test string returns: %d ('%s' vs. '%s')\n", strcmp(hello, buff), hello, buff);
	close(fd);
	fclose(f);

	printf("getpid works: %d\n", (getpid() > 1) &&  (getpid() < 65536));
	printf("getuid works: %d\n", (getuid() >= 0) &&  (getuid() < 65536));
	printf("geteuid works: %d\n", (geteuid() >= 0) &&  (geteuid() < 65536));
	printf("getgid works: %d\n", (getgid() >= 0) &&  (getgid() < 65536));
	printf("getegid works: %d\n", (getegid() >= 0) &&  (getegid() < 65536));

	/* ioctl and kill are tested via stdio */

	printf("link: %d\n", link(tmp, tmp2));
	fd = open(tmp2, 0);
	printf("read: %d\n", read(fd, buff, sizeof(buff)));
	printf("test string returns: %d ('%s' vs. '%s')\n", strcmp(hello, buff), hello, buff);
	close(fd);

	/* mknod is not tested because it needs root */

	/* mount is not tested as it needs superuser privileges */

	printf("nice 1:  %d\n", nice(1));
	printf("nice -1: %d\n", nice(-1));

	/* open and pause are tested already via stdio */

	/* pipe is already tested at popen */

	/* setuid/setgid are privileged */

	/* signal is already tested in signal.c */

	/* umask, utime and stat are tested in stat.c */


	/* stime needs root */

	printf("Sync: %d\n", sync());

	/* time and ftime are already tested in time.c */

	#warning times()

	printf("unlink %s: %d\n", tmp, unlink(tmp));
	printf("unlink %s: %d\n", tmp2, unlink(tmp2));
	printf("access %s: %d\n", tmp, access(tmp, 0));
	printf("access %s: %d\n", tmp2, access(tmp2, 0));

}
